<?php
/** ensure this file is being included by a parent file */

if ( ! ( defined( '_VALID_CB' ) || defined( '_JEXEC' ) || defined( '_VALID_MOS' ) ) ) { die( 'Direct Access to this location is not allowed.' ); }

class getDonateMeTab  extends cbTabHandler {
	/**
	* Constructor
	*/
	function getDonateMeTab() {
		$this->cbTabHandler();
	}
	/**
	 * Display donation history of a user
	 *
	 * @param object $tab
	 * @param object $user
	 * @param int $ui
	 */
	function getDisplayTab($tab,$user,$ui) {		
		$db = & JFactory::getDBO() ;
		$params = $this->params ;	
		$campaignIds = $params->get('campaign_id');	
		if ($campaignIds)	
			$sql = 'SELECT COUNT(*) FROM #__jd_donors WHERE published = 1 AND hide_me=0 AND receive_user_id = '.$user->id." AND campaign_id IN ($campaignIds)";
		else
			$sql = 'SELECT COUNT(*) FROM #__jd_donors WHERE published = 1 AND hide_me=0 AND receive_user_id = '.$user->id;
		$db->setQuery($sql) ;
		$total = $db->loadResult();		
		$numebrDonors = $params->get('number_donors', 10);		
		$pagingParams = $this->_getPaging(array(),array("entries_"));
		if ($pagingParams["entries_limitstart"] === null) $pagingParams["entries_limitstart"] = "0";
		if ($numebrDonors > $total) $pagingParams["entries_limitstart"] = "0";
		if ($campaignIds)
			$sql=" SELECT a.* FROM #__jd_donors AS a WHERE published = 1 AND receive_user_id=$user->id AND hide_me = 0 AND campaign_id IN ($campaignIds)"
				. " Order by a.id DESC "			
				. "\n LIMIT ".($pagingParams["entries_limitstart"]?$pagingParams["entries_limitstart"]:"0").",".$numebrDonors;			
		else
			$sql=" SELECT a.* FROM #__jd_donors AS a WHERE published = 1 AND receive_user_id=$user->id AND hide_me = 0 "
			. " Order by a.id DESC "			
			. "\n LIMIT ".($pagingParams["entries_limitstart"]?$pagingParams["entries_limitstart"]:"0").",".$numebrDonors;
			;
		$db->setQuery($sql) ;
		$rowDonors = $db->loadObjectList();				
		//Get currency symbol
		$sql = 'SELECT config_value FROM #__jd_configs WHERE config_key="currency_symbol"';
		$db->setQuery($sql);
		$currencySymbol = $db->loadResult();	
		ob_start();
		$this->_drawDonorsList($rowDonors, $user, $currencySymbol, $pagingParams, $numebrDonors, $total);
		$return = ob_get_contents();
		ob_end_clean();
		return $return;
	}

	/**
	 * Draw the output for donation history
	 *
	 * @param array $rows
	 */
	function _drawDonorsList($rows, $user, $symbol, $pagingParams, $numebrDonors, $total) {		
		require_once (JPATH_ROOT.'/components/com_jdonation/helper/helper.php');
		JoomDonationHelper::loadLanguage();
		$percent = 100 - JoomDonationHelper::getConfigValue('percent_commission') ;
		$params = $this->params ;
		$onlyShowToOwner = $params->get('only_show_to_owner', 0);
		$currentUser = & JFactory::getUser() ;
		global $Itemid ;
		if (!$Itemid) {
			$Itemid = JoomDonationHelper::getItemid();
		}
		if ($onlyShowToOwner && ($user->id != $currentUser->get('id')))
			$showRecords = false ;
		else 
			$showRecords = true ;
		$dateFormat = JoomDonationHelper::getConfigValue('date_format');
		if ($showRecords) {
		?>
			<table width="100%" cellspacing="0" cellpadding="0" class="jd_donorlist">
				<tr>
					<td class="sectiontableheader">
						<?php echo JText::_('JD_NO'); ?>
					</td>
					<td class="sectiontableheader">
						<?php echo JText::_('JD_FIRST_NAME'); ?>
					</td>
					<td class="sectiontableheader">
						<?php echo JText::_('JD_LAST_NAME'); ?>
					</td>
					<td class="sectiontableheader">
						<?php echo JText::_('JD_DONATION_AMOUNT').' ('.$symbol.')';?>
					</td>
					<td class="sectiontableheader">
						<?php echo JText::_('JD_DONATION_DATE') ?>
					</td>					
				</tr>
				<?php
					if (count($rows)) {
						$tabs = array('sectiontableentry1', 'sectiontableentry2');
						$k = 0;
						for($i=0, $n = count($rows); $i < $n; $i++) {
							$row = $rows[$i];
							$tab = $tabs[$k];
						?>
						<tr class="<?php echo $tab; ?>">
							<td>
								<?php echo ($i + 1); ?>
							</td>
							<td>
								<?php echo $row->first_name ; ?>
							</td>
							<td>
								<?php echo $row->last_name ; ?>
							</td>
							<td>
								<?php echo  number_format($row->amount*$percent/100, 2); ?>
							</td>
							<td>
								<?php echo JHTML::_('date', $row->created_date, $dateFormat); ?>
							</td>							
						</tr>
						<?php	
							$k =  1 - $k;	
						}
						if ($total > $numebrDonors) {
						?>
							<tr>
								<td colspan="5">
									<div align="center"><?php echo $this->_writePaging($pagingParams ,"entries_", $numebrDonors, $total);  ?></div>
								</td>
							</tr>
						<?php	
						}
					} else {
					?>	
						<tr>
							<td colspan="6"><p class="message"><?php echo JText::_('JD_NO_DONATIONS'); ?></p></td>
						</tr>
					<?php	
					}	
				?>											
			</table>
		<?php				
		}
		?>						
			<p class="message">
				<strong><?php echo JText::_('JD_WANT_TO_DONATE'); ?></strong>
			</p>
			<div class="donate_container" style="margin-bottom: 20px; text-align: right;">
				<form method="post" action="index.php?Itemid=<?php echo $Itemid ; ?>" name="donate_form">
					<input type="hidden" name="option" value="com_jdonation" />
					<input type="hidden" name="view" value="donation" />
					<input type="hidden" name="receive_user_id" value="<?php echo $user->id; ?>" />
					<strong><?php echo JText::_('JD_DONATION_AMOUNT'); ?></strong>:
					<input type="text" name="amount" size="10" class="inputbox" />
					<input type="submit" class="button" value="<?php echo JText::_('JD_DONATE'); ?>" />
				</form>
			</div>
			<?php
				if (count($rows)) {
					$my = & JFactory::getUser() ;
					$userId = $my->id ;
					if ($userId == $user->id) {
					?>
						<p class="message">
							<strong><?php echo JText::_('JD_DOWNLOAD_REPORT_MSG'); ?>&nbsp;<?php echo JText::_('JD_CLICK'); ?>&nbsp;<a href="index.php?option=com_jdonation&task=csv_export&receive_user_id=<?php echo $user->id; ?>"><?php echo JText::_('JD_HERE'); ?></a></strong>
						</p>
					<?php	
					}
				}
			?>
		<?php			
	}
}
?>
